import bge
dict = bge.logic.globalDict
#====================================     

State = type("State", (object,), {})
#====================================     
class State(object):
    def __init__(self, FSM):
        self.FSM = FSM
        self.timer = 0
        self.startTime = 0
    def Enter(self):
        self.timer = 0
        self.startTime = 0
    def Execute(self):
        print('Executing')
    def Exit(self):
        print('Exiting')

#==================================== 
            
class Example(State):
    def __init__(self,FSM):
        super(Example, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        super(Example, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        #self.FSM.ToTransition('toExample')
        
    def Exit(self):
        pass

#==================================== 

class Startup(State):
    def __init__(self,FSM):
        super(Startup, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        super(Startup, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1

        if self.FSM.stateLife == 5:
            self.FSM.ToTransition('toWalk')
        print('player FSM')
        
    def Exit(self):
        pass

#==================================== 
            
class Walk(State):
    def __init__(self,FSM):
        super(Walk, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        o = self.FSM.owner.obj
        c = self.FSM.owner
        o['getoffboard'] = False
        o['getonboard'] = False

        if c.arm == None:
            
            c.arm = o.childrenRecursive['Char4']

        self.walk_weight = 1
        self.run_weight = 1
        self.run_speed = 0.0
        self.turn_weight = 0
        self.FSM.owner.walking = True
        dict['walking'] = True
        dict['walk'] = 1
        print('fsm enter walk')

        super(Walk, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        o = self.FSM.owner.obj
        c = self.FSM.owner
        #print(o.worldPosition.z)
        #print(o['getonboard'], 'dict onboard')
        #print(dict['walk'], 'fsm walk walk')
        if self.FSM.stateLife == 2:
            if o['stance']:
                o.applyRotation([0,0,3.14], True)
                o['stance'] = False
        #         o['requestAction'] = 'fak_offboard' 
        #         print('request fak offboard')            
        #     else:
        #         o['requestAction'] = 'reg_offboard'                 
        #         print('request reg offboard') 
        # if self.FSM.stateLife > 5:
        #     o['requestAction'] = 'reg_idle'                 
        ground_rays = c.get_ground_ray()
        if ground_rays[0][0] != None:
            dist = c.get_ground_dist(ground_rays)
            c.set_walk_z(dist)
            #print(dist, 'setting height')

        if self.FSM.stateLife > 4:
            self.check_onboard()
            self.check_jump()

            moving = c.walk_movement()
            
            self.get_walk_weight()
            self.idle_blend()
        else:
            dict['walk'] = 1


    def check_onboard(self):

        o = self.FSM.owner.obj
        print(o['getonboard'], 'getonboard')



        if dict['walk'] == 0:
            o['getonboard'] = True
            self.FSM.ToTransition('toRoll')
            print('onboard', dict['walk'], o['getonboard'])





        if dict['yBut'] == 1 and dict['last_yBut'] == 0:
            o['getonboard'] = True
            self.FSM.ToTransition('toRoll')

    def check_jump(self):
        if dict['xBut'] == True or dict['kb_space'] == 1: 
            if dict['last_xBut'] == 0:
                self.FSM.ToTransition('toWalkJump')

    def idle_blend(self):
        arm = self.FSM.owner.arm
        arm.playAction('reg_idle1', 1,120, layer=1, play_mode=1, speed=1, blendin=10)
        if self.FSM.stateLife > 20:
            frame = arm.getActionFrame(2) + .5 * self.run_speed
            if frame > 30:
                frame = 0
            arm.stopAction(2)
            arm.playAction('reg_nwalk3', 0,30, layer=2, play_mode=1, speed=self.run_speed, blendin=0, layer_weight=self.walk_weight)
            arm.setActionFrame(frame, 2)
            #print(self.walk_weight, frame)

            

            frame = arm.getActionFrame(3) + .5 * self.run_speed
            if frame > 30:
                frame = 0
            arm.stopAction(3)
            arm.playAction('reg_run.003', 0,30, layer=3, play_mode=1, speed=self.run_speed, blendin=0, layer_weight=self.run_weight)
            arm.setActionFrame(frame, 3)
            #print(frame, 'frame')
            #print(self.run_weight, frame)
            
        # if self.turn_weight > 0:
        #     tw = abs(self.turn_weight - 1)
        #     #tw = self.turn_weight
        #     arm.stopAction(4)
        #     arm.playAction('bwalk_right', 1,60, layer=4, play_mode=1, speed=self.run_speed, blendin=0, layer_weight=tw)
        # elif self.turn_weight < 0:
        #     tw = abs(abs(self.turn_weight) - 1)
        #     #tw = self.turn_weight
        #     arm.stopAction(4)
        #     arm.playAction('bwalk_left', 1,60, layer=4, play_mode=1, speed=self.run_speed, blendin=0, layer_weight=tw)


    def get_walk_weight(self):
        #print(self.FSM.owner.linearVelocity.y) 


        o = self.FSM.owner.obj
        w = abs(o.linearVelocity.x)
        #wt = 3.5
        #yt = 8
        wt = 1.7
        yt = 3
        out2 = 0
        if w < wt:
            out = w / wt
        else:
            out = 1
            #print('running', w)
            out2 = w / yt
        out = abs(1 - out)
        out2 = abs(1 - out2)
        tgww = round(out, 3)
        tgrw = round(out2, 3)
        incer = .05
        if self.walk_weight < tgww:
            self.walk_weight += incer
        if self.walk_weight > tgww:
            self.walk_weight -= incer
        if self.run_weight <= tgrw:
            self.run_weight += incer
        if self.run_weight > tgrw:
            self.run_weight -= incer
        if self.walk_weight <= 0:
            self.walk_weight = 0
        if self.walk_weight > .95:            
            self.walk_weight = 1        
        if self.run_weight <= 0:
            self.run_weight = 0
        if self.run_weight > .95:
            self.run_weight = 1


        if dict['kb_lsh'] == 2 or dict['aBut'] == 1:
            self.run_speed = 1.3
        else:
            self.run_speed = .8
        #print(self.run_speed, '---', self.walk_weight, 'walk weight', self.run_weight, 'run weight')

    def Exit(self):
        self.FSM.owner.arm.stopAction(0)
        self.FSM.owner.arm.stopAction(1)
        self.FSM.owner.arm.stopAction(2)
        self.FSM.owner.arm.stopAction(3)
        dict['walk'] = 0


#==================================== 
            
class WalkAir(State):
    def __init__(self,FSM):
        super(WalkAir, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        #arm = self.FSM.owner.arm
        #arm.playAction('a_jump_t', 27, 27, layer=1, play_mode=0, speed=1, blendin=5)
        super(WalkAir, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        #self.FSM.ToTransition('toLand')
        arm = self.FSM.owner.arm
        arm.playAction('a_jump_t', 23, 23, layer=3, play_mode=1, speed=1, blendin=5)
        #if self.FSM.stateLife > 50:
            #self.FSM.ToTransition('toWalk')
        #limit fall speed
        if self.FSM.owner.obj.linearVelocity.z < -10:
            self.FSM.owner.obj.linearVelocity.z = -10
        #ground_rays = self.FSM.owner.get_ground_ray()    
        ground_rays = self.FSM.owner.get_ground_ray() 
        if ground_rays[0][0] != None:

            dist = self.FSM.owner.get_ground_dist(ground_rays)
            if dist < .4:
                self.FSM.ToTransition('toWalkLand')  

        moving = self.FSM.owner.walk_movement()              
        
    def Exit(self):
        self.FSM.owner.arm.stopAction(0)
        self.FSM.owner.arm.stopAction(1)
        self.FSM.owner.arm.stopAction(2)
        self.FSM.owner.arm.stopAction(3)

#==================================== 
            
class WalkJump(State):
    def __init__(self,FSM):
        super(WalkJump, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1

        arm = self.FSM.owner.arm
        arm.playAction('a_jump_t', 1, 23, layer=3, play_mode=0, speed=1, blendin=5)
            

        super(WalkJump, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        arm = self.FSM.owner.arm
        o = self.FSM.owner.obj

        moving = self.FSM.owner.walk_movement()              

        if self.FSM.stateLife == 10:
                force = [ 0.0, 0.0, dict['walk_jump_force']]
                if o.linearVelocity.z < 10:
                     o.applyForce(force, True)

        if self.FSM.stateLife > 27:
            self.FSM.ToTransition('toWalkAir')
        
    def Exit(self):
        pass

#==================================== 
            
class WalkLand(State):
    def __init__(self,FSM):
        super(WalkLand, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        self.FSM.owner.arm.playAction('a_jump_t', 23, 50, layer=5, play_mode=0, speed=1, blendin=5)
        super(WalkLand, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        self.FSM.owner.obj.linearVelocity.x *= .8
        self.FSM.owner.obj.linearVelocity.y *= .8
        # arm = self.FSM.owner.arm
        
        # print('af', arm.getActionFrame(5))
        # if arm.getActionFrame(5) > 30:
        #     print('stopping land')
        #     arm.stopAction(5)
        #     arm.playAction('reg_idle1', 1,120, layer=1, play_mode=1, speed=1, blendin=2)
        if self.FSM.stateLife > 8:
            self.FSM.ToTransition('toWalk')

        ground_rays = self.FSM.owner.get_ground_ray() 
        if ground_rays[0][0] != None:
            dist = self.FSM.owner.get_ground_dist(ground_rays)
            self.FSM.owner.set_walk_z(dist)

    def Exit(self):
        pass

#==================================== 
            
class WalkHang(State):
    def __init__(self,FSM):
        super(WalkHang, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        super(WalkHang, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        #self.FSM.ToTransition('toLand')
        
    def Exit(self):
        pass

#==================================== 
            
class WalkClimb(State):
    def __init__(self,FSM):
        super(WalkClimb, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        super(WalkClimb, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        #self.FSM.ToTransition('toLand')
        
    def Exit(self):
        pass                                

#==================================== 
            
class WalkHurdle(State):
    def __init__(self,FSM):
        super(WalkHurdle, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        super(WalkHurdle, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        #self.FSM.ToTransition('toLand')
        
    def Exit(self):
        pass                                


#==================================== 
            
class Roll(State):
    def __init__(self,FSM):
        super(Roll, self).__init__(FSM)    
        
    def Enter(self):
        self.FSM.stateLife = 1
        self.FSM.owner.walking = False
        dict['walking'] = False
        super(Roll, self).Enter()        
        
    def Execute(self):
        self.FSM.stateLife += 1
        if dict['walk'] == 1 or self.FSM.owner.obj['getoffboard'] == True:
            dict['walk'] = 1
            self.FSM.owner.obj['getoffboard'] = True
            self.FSM.ToTransition('toWalk')
            print('fsm to walk')
        print('rolling')
        #self.FSM.ToTransition('toLand')
        
    def Exit(self):
        pass

#==================================== 
